#ifndef __PBO_H__
#define __PBO_H__

//#define __STL_NO_NAMESPACES
#include <vector>
#include <string>
using namespace std;

class    PboEntry
{
public:

   PboEntry();

   int      Read(FILE *f);

   int      Write(FILE *f);

public:

   string   filename;
   char     unknown[16];
   int      size;
};



class	   PboPack
{
public:
	PboPack();

	virtual ~PboPack();

   virtual  int   Extract(const char *name);   

   virtual  int   Compress(const char *outfile, const char *path);   

protected:

   virtual  void  CompressDir();

   virtual  void  CompressTree();

   virtual  void  CompressFile(const char *fn);

   virtual  void  CreateDirs(const string &s);

protected:

   // typedefs
   
   typedef  vector<PboEntry*> PboEntryVector;

   typedef  vector<char>      PboDataVector;
   // vars

   PboEntryVector             Entry;

   PboDataVector              Data;

   string                     CurPath;
};


#endif